UPDATE-ALTERNATIVES(8)

NOM
update-alternatives - maintenance des liens symboliques déterminant les noms par défaut de certaines commandes

SYNOPSIS
update-alternatives [options] --install lien nom chemin priorité [--slave lien nom chemin]...

update-alternatives [options] --remove nom chemin

update-alternatives [options] --auto nom

update-alternatives [options] --display nom

update-alternatives [options] --list nom

update-alternatives [options] --config nom

DESCRIPTION
update-alternatives crée, enlève, conserve et affiche des informations concernant les liens symboliques qui forment le système Debian des « alternatives ».

Il est possible d'installer, sur un même système et en même temps, des programmes qui remplissent des fonctions identiques ou semblables. Par exemple, beaucoup de systèmes installent plusieurs éditeurs de texte en même temps. Cela permet à chaque utilisateur d'un système de choisir, s'il le désire, un éditeur de texte différent ; mais cela rend les choses difficiles pour le programme qui doit choisir un bon éditeur de texte quand l'utilisateur n'a pas fait de choix précis.

Le système Debian des « alternatives » essaie de résoudre ce problème. Tous les fichiers qui proposent des fonctions interchangeables se servent d'un nom générique qui se trouve dans l'arborescence. Le système des « alternatives » et l'administrateur système font connaître ensemble le fichier qui est réellement visé par ce nom générique. Par exemple, si les éditeurs de texte ed(1) et nvi(1) sont tous les deux installés, le système des « alternatives » fait que le nom générique /usr/bin/editor renvoie par défaut à /usr/bin/nvi. L'administrateur système peut remplacer cette assignation par /usr/bin/ed et le système des « alternatives » ne la changera pas tant qu'on ne lui aura pas demandé explicitement de le faire.

Le nom générique n'est pas un lien symbolique direct vers l'alternative choisie. c'est en fait un lien symbolique vers un nom situé dans le répertoire des « alternatives », lequel nom est à son tour un lien symbolique vers le fichier réellement visé. Les modifications faites par l'administrateur système sont ainsi confinées dans le répertoire /etc : le FHS (lisez-le) donne de Bonnes Raisons de faire ainsi.

Chaque fois qu'un paquet proposant un fichier pour une fonction déterminée, est installé, modifié ou désinstallé, update-alternatives est appelé pour mettre à jour les informations concernant ce fichier dans le système des « alternatives ». On appelle habituellement update-alternatives dans les scripts postinst et prerm des paquets Debian.

Il est souvent utile de synchroniser certaines alternatives, de manière à pouvoir les manipuler globalement ; par exemple, quand plusieurs versions de vi(1) sont installées, la page de manuel qui est visée par /usr/share/man/man1/vi.1 devrait correspondre à /usr/bin/vi. update-alternatives gère ce problème avec les liens principaux (« master ») et les liens secondaires (« slave ») Quand le lien principal est changé, tous les liens secondaires associés sont changés. Un lien principal et ses liens secondaires associés composent un groupe de liens.

À tout moment, un groupe de liens est dans l'un des deux modes suivants : automatique ou manuel. Quand un groupe est dans le mode automatique et que des paquets sont installés ou désinstallés, le système des « alternatives » décide automatiquement s'il doit mettre à jour les liens et comment le faire. Dans le mode manuel, le système des « alternatives » ne change pas les liens et laisse l'administrateur système prendre toutes les décisions.

Un groupe de liens est en mode automatique quand il est crée sur un système pour la première fois. Quand l'administrateur système modifie le paramétrage automatique du système, update-alternatives le remarquera la prochaine fois qu'il sera lancé pour ce groupe aux liens modifiés et il fera passer ce groupe en mode manuel.

À chaque alternative est associée une priorité. Quand un groupe de liens est en mode automatique, l'alternative visée par les éléments du groupe est celle qui possède la priorité la plus élevée.

Quand on utilise l'option --config, update-alternatives affiche toutes les possibilités du groupe pour lequel nom est le lien principal. On vous demandera alors quelle possibilité vous choisissez pour ce groupe. Dès qu'une modification est faite, le groupe de liens n'est plus en mode auto. Il vous faudra utiliser l'option --auto pour revenir au mode automatique.

TERMINOLOGIE
Comme les opérations de update-alternatives sont très compliquées, voici quelques termes qui faciliteront l'explication.

nom générique
    C'est un nom, par exemple /usr/bin/editor, qui renvoie, à travers le système des « alternatives », à l'un des fichiers qui remplissent des fonctions similaires.

lien symbolique
    Sans en dire plus, c'est un lien symbolique qui se trouve dans le répertoire alternatives, répertoire que l'administrateur système est supposé déterminer.

alternative
    C'est le nom d'un fichier particulier dans l'arborescence ; il peut être accessible, via un nom générique, avec le système des « alternatives ».

répertoire des alternatives
    C'est le répertoire qui contient les liens symboliques ; il s'agit par défaut de /etc/alternatives.

répertoire administratif
    C'est le répertoire qui contient des renseignements sur l'état de update-alternatives. Il s'agit par défaut de /var/lib/dpkg/alternatives.

groupe de liens
    C'est un ensemble de liens symboliques corrélés, de manière qu'on puisse les mettre à jour en une seule fois.

lien principal
    Dans un groupe de liens, c'est le lien qui détermine comment sont configurés les autres liens du groupe.

lien secondaire (« slave »)
    Dans un groupe de liens, c'est un lien déterminé par le paramétrage du lien principal.

mode automatique
    Quand un groupe de liens est en mode automatique, le système des « alternatives » assure que les liens dans le groupe pointent vers l'alternative possédant la priorité la plus élevée dans ce groupe.

mode manuel
    Quand un groupe de liens est en mode manuel, le système des « alternatives » ne modifie pas le paramétrage de l' administrateur système.

OPTIONS
Pour toute opération significative, on doit demander une seule action à update-alternatives. Pour toute action, on peut préciser un certain nombre d'options.

  Options générales

--verbose
    produit plus de commentaires sur ce que fait update-alternatives.

--quiet
    ne produit pas de commentaires à moins qu'une erreur survienne. Cette option n'est pas encore implémentée.

--test
    En vérité, ne fait rien ! dit simplement ce qui pourrait être fait. Cette option n'est pas encore implémentée.

--help
    Donne des renseignements sur l'utilisation (et donne la version de update-alternatives).

--version
    donne la version de update-alternatives et des renseignements sur l'utilisation.

--altdir répertoire
    Donne le répertoire des alternatives, quand il est différent de celui par défaut.

--admindir répertoire
    Donne le répertoire administratif, quand il est différent de celui par défaut.

  ACTIONS

--install lien gen chemin pri [--slave slien sgen schemin] ...
    Ajoute un groupe d'alternatives au système. gen est le nom générique du lien principal, lien est le nom de son lien symbolique, et chemin est l'alternative présentée pour le lien principal. sgen, slien et schemin sont les nom générique, lien symbolique et alternative pour un lien secondaire. On peut indiquer zéro ou plusieurs options --slave chacune suivie par trois arguments.

    Quand le lien principal spécifié existe déjà dans les enregistrements du système des « alternatives », les renseignements fournies sont ajoutées dans un nouvel ensemble d'alternatives pour le groupe. Sinon, un nouveau groupe contenant ces informations est ajouté et mis en mode automatique. Quand un groupe est en mode automatique, et quand la priorité des alternatives nouvellement ajoutées est plus élevée que toutes celles des alternatives installées dans ce groupe, les liens symboliques sont mis à jour et pointent vers les alternatives nouvellement ajoutées.

--remove nom chemin
    Enlève une alternative et tous ses liens secondaires associés. nom est un nom dans le répertoire des « alternatives », et chemin est un nom de fichier auquel nom peut être lié. Quand nom est en effet lié à chemin, nom est mis à jour et pointe vers une autre alternative adéquate, ou bien est enlevé si il n'y en a pas d'autre. De même, les liens secondaires associés sont mis à jour ou enlevés. Quand le lien ne pointe pas déjà sur chemin, aucun lien n'est modifié ; seules les informations sur l'alternative sont supprimées.

--auto nom
    Passe le lien symbolique principal nom en mode automatique. En même temps, le lien symbolique principal et ses liens secondaires sont mis à jour et pointent vers les alternatives avec les priorités les plus élevées.

--display nom
    Affiche des renseignements sur le groupe de liens pour lequel nom est le lien principal. L'information affichée comprend le mode du groupe (auto ou manuel), vers quelle alternative le lien symbolique pointe actuellement, quelles autres alternatives sont disponibles (et les liens secondaires associés), et l'alternative actuellement installée qui possède la priorité la plus élevée.

--list link
    Affiche toutes les cibles du groupe de liens.

FICHIERS

/etc/alternatives/
    Le répertoire des « alternatives » par défaut. Peut être remplacé avec l'option --altdir.

/var/lib/dpkg/alternatives/
    Le répertoire administratif par défaut. Peut être remplacé avec l'option --admindir

ÉTAT DE SORTIE

0   L'action demandée s'est correctement déroulée.

2   Des problèmes sont survenus lors de l'analyse de la ligne de commande ou bien pendant l'exécution de l'action.

DIAGNOSTICS
update-alternatives bavarde sans arrêt sur ses opérations sur le canal de sortie standard. Quand un problème arrive, update-alternatives envoie des messages d'erreur sur la sortie d'erreur standard et retourne un état de sortie égal à 2. Ces diagnostics devraient s'expliquer d'eux-mêmes ; Si ce n'est pas le cas, veuillez faire un rapport de bogue.

BOGUES
Si vous trouvez un bogue, veuillez envoyer un rapport de bogue au système de suivi des bogues de Debian, ou bien, si ce n'est pas possible, envoyez un courriel directement à l'auteur.

Si vous trouvez une discordance entre l'action de update-alternatives et cette page de manuel, c'est qu'il y a un bogue, soit dans l'implémentation soit dans la documentation ; faites un rapport.

AUTEUR
Le programme de Debian « update-alternatives » est sous copyright 1995 Ian Jackson. C'est un logiciel libre ; Voyez la « GNU General Public Licence » version 2 ou supérieure pour les conditions du copyright. Il n'y a AUCUNE garantie.

Cette page de manuel est sous copyright 1997/98 Charles Briscoe-Smith. C'est une documentation libre ; Voyez la « GNU General Public Licence » version 2 ou supérieure pour les conditions du copyright. Il n'y a AUCUNE garantie.

On peut trouver la licence GNU GPL dans /usr/share/common-licenses/GPL sur tous les systèmes Debian.

VOIR AUSSI
ln(1), FHS, le standard pour les systèmes de fichiers Linux.

TRADUCTION
Philippe Batailler. Nov 200O